﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Quick_Merge
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        List<int> Random = new List<int>();
        List<int> rq = new List<int>();
        List<int> rm = new List<int>();
        int pivot;
        int temp=0;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Random.Clear();
            rq.Clear();
            rm.Clear();
            for (int i = 0; i < 1000000; i++)
            {
                Random.Add(r.Next());
                rq.Add(Random[i]);
                rm.Add(Random[i]);
            }
            Quick.RunWorkerAsync();
            Merge.RunWorkerAsync();
        }

        private void Quick_DoWork(object sender, DoWorkEventArgs e)
        {
            double t1 = DateTime.Now.TimeOfDay.TotalMilliseconds;
            Q(0, rq.Count - 1);
            double t2 = DateTime.Now.TimeOfDay.TotalMilliseconds;
            this.Invoke(new Action(() =>
            {
                label4.Text = (t2 - t1).ToString();
                label6.Text = (Convert.ToInt32(Convert.ToDouble(label4.Text) / Convert.ToDouble(label5.Text)*100)).ToString()+" %";
            }));
        }

        void Q(int Low, int High)
        {
            if (High > Low)
            {
                QSort(Low,ref pivot, High);
                Q(Low, pivot - 1);
                Q(pivot + 1, High);
            }
        }

        void QSort(int low,ref int pivot, int high)
        {
            int j = low;
            for (int i = low+1; i <= high; i++)
            {
                if (rq[i] < rq[low])
                {
                    j++;
                    temp = rq[i];
                    rq[i] = rq[j];
                    rq[j] = temp;
                }
            }
            temp = rq[j];
            rq[j] = rq[low];
            rq[low] = temp;
            pivot = j;
        }

        private void Merge_DoWork(object sender, DoWorkEventArgs e)
        {
            double t3 = DateTime.Now.TimeOfDay.TotalMilliseconds;
            mergesort(0,rm.Count-1);
            double t4 = DateTime.Now.TimeOfDay.TotalMilliseconds;
            label5.Invoke(new Action(() =>
            {
                label5.Text = (t4 - t3).ToString();
            }));
        }

        void mergesort(int low,int high)
        {
            if (low < high)
            {
                int mid = (low + high) / 2;
                mergesort(low, mid);
                mergesort(mid + 1, high);
                mergsort(low, mid, high);
            }

        }

        void mergsort(int low, int mid, int high)
        {
            int i=low, j=mid+1, k=low;
            List<int> U = new List<int>();
            while (i <= mid && j <= high)
            {
                if (rm[i] < rm[j])
                {
                    U.Add(rm[i]);
                    i++;
                }
                else
                {
                    U.Add(rm[j]);
                    j++;
                }
            }
            if (i > mid)
            {
                for (int c = 0; c <= high - j; c++)
                {
                    U.Add(rm[j + c]);
                }
            }
            else
            {
                for (int c = 0; c <= mid - i; c++)
                {
                    U.Add(rm[i + c]);
                }
            }
            for (int c = 0; c <= high - low; c++)
            {
                rm[low + c] = U[c];
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

        }
    }
}
